;;; "clp-ga-pool.scm"

;;; ===== POOL =====
; Erzeugen des POOLS.
; Es werden n verschiedene zufaellig gefuellte Containerlisten erzeugt.
(define
  (erzeuge-pool container-liste n)
  (cond
    ((positive? n)
     (cons
      (erzeuge-pool-element
       (umbau ; veraendert die stueckeliste
        (cdar container-liste)
        (random (length (cdar container-liste)))
        '()) ; da endrekursiv !
       (cdr container-liste)
       '()) ; da endrekursiv !
      (erzeuge-pool container-liste (sub1 n))))
    (else  '())))

;;; ----- umbau -----
; die Liste der vorhandenen Stuecke wird an der uebergebenen Stelle auseinander
; geschnitten und wieder zusammengesetzt. Reihenfolge z.T. geaendert.
(define
  (umbau stuecke stelle akku)
  (cond
    ((null? stuecke) akku)
    ((zero? stelle)
     (append stuecke akku))
    (else
     (umbau (cdr stuecke) (sub1 stelle) (cons (car stuecke) akku)))))

;;; ----- erzeuge-pool-element -----
; Aus der Stueckeliste werden in jeden Container gerade soviel Stuecke getan
; bis er nicht ueberfuellt ist.
; Achtung: die Containerliste enthaelt hier nur die tatsaechlichen Container! 
(define
  (erzeuge-pool-element stuecke-liste container-liste akku)
  (cond
    ((null? container-liste) ; fertig, noch restliche Stuecke davor!
     (cons
      (cons 0 stuecke-liste)
      (reverse akku)))
    ((null? stuecke-liste) ; sollte nicht sein, keine Stuecke mehr!
     (cons
      (cons 0 stuecke-liste)
      (reverse akku)))
    ((>                     ; zu viel?
      (apply + (cons (car stuecke-liste) (cdar container-liste)))
      (caar container-liste))
     (erzeuge-pool-element
      stuecke-liste
      (cdr container-liste)
      (cons (car container-liste) akku)))
    (else                   ; rein das Stueck!
     (erzeuge-pool-element
      (cdr stuecke-liste)
      (cons
       (cons
        (caar container-liste) ; Fassung
        (cons
         (car stuecke-liste)
         (cdar container-liste)))  ; mit Stueck
       (cdr container-liste))
      akku))))
;;; ----- Test -----
;(load "clp-ga-daten.scm")
;(erzeuge-pool *Container* 1)
