;;; "clp-ga-projekt.scm"
; Neue Modellierung fuer das CLP mit Genetischen Algorithmen
; Vorgegeben ist eine Liste mit Containern und eine Liste mit Stuecken
; Ueberschreitungen werden akzeptiert, allerdings mit mehrfachem Gewicht
; als malus bewertet.
; Die nicht eingebauten Stuecke liegen dazu in einem "Container" 
; mit dem Fassungsvermoegen 0.
(load "breakpoint.scm")
;;; Die vorliegende Loesung weicht dadurch von der Standardloesung ab, dass
;;; keine Individuen untereinander "Gene" austauschen, sondern nur
;;; die Container eines (!) Individuums jeweils. Dadurch erspart man sich
;;; die Betrachtungen der Zulaessigkeit. Der Pool ermoeglicht es aber, schnell
;;; unguenstige Vorgaben auszuschliessen.

(load "clp-ga-daten.scm") ; alternativ:
;(load "clp-ga-daten-2.scm")
(load "clp-ga-bewertung.scm")
(load "clp-ga-mutation.scm")
(load "clp-ga-selektion.scm")
(load "clp-ga-generation.scm")
(load "clp-ga-pool.scm")
(load "clp-ga-crossing-over.scm")

;;; ===== Test =====
; 620 / 1220 ist maximum!
(let
    ((beste (car (bestimme-beste 1 (Generationen-folge (erzeuge-pool *Container* 20) 40) '() '()))))
  (display beste) (newline)
  (display (bewerte beste)) (newline))
